%if 0%{?el6} || 0%{?el7}
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_version: %global python2_version 2.6}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%else
%global with_python3 1
%endif

%if 0%{?el7} || 0%{?fedora}
%{!?with_doc: %global with_doc 1}
%endif

%global obspy_programs dataless2resp dataless2xseed flinn-engdahl indexer mopad mseed-recordanalyzer plot print reftek-rescue runtests scan xseed2dataless

%global srcname obspy
%global commit 9c8ad50d84e2f852403b021ae5692e12ca08f043
%global shortcommit %(c=%{commit}; echo ${c:0:7})

Name:		python-%{srcname}
Version:	0.10.3
Release:	1%{?dist}
Summary:	A Python Toolbox for seismology/seismological observatories

Group:		Development/Libraries
License:	LGPLv3
URL:		http://www.obspy.org/
Source0:	https://github.com/obspy/obspy/archive/%{commit}/%{name}-%{commit}.tar.gz
Patch0001:	obspy-numpy-1.4.patch

BuildRequires:	python2-devel
BuildRequires:	python-setuptools
%if 0%{?el6}
BuildRequires:	python-argparse
BuildRequires:	python-importlib
%endif
BuildRequires:	python2-future >= 0.12.4
BuildRequires:	libmseed-devel >= 2.12
BuildRequires:	evalresp-devel >= 3.3.3
BuildRequires:	numpy > 1.4.0
BuildRequires:	python-mock
BuildRequires:	scipy >= 0.7.2
BuildRequires:	python-lxml
%if 0%{?fedora} <= 23
BuildRequires:	python-matplotlib
%else
BuildRequires:	python2-matplotlib
%endif
BuildRequires:	python-basemap
BuildRequires:	python-basemap-data
BuildRequires:	python-basemap-data-hires
BuildRequires:	python-sqlalchemy

# Tests
%if 0%{?fedora}
BuildRequires:	python-flake8 >= 2
%endif
BuildRequires:	python-nose

# Documentation
%if 0%{?with_doc}
BuildRequires:	help2man
BuildRequires:	python-sphinx
BuildRequires:	python-sphinx-theme-bootstrap
BuildRequires:	python-pybtex
BuildRequires:	python-suds-jurko
%endif # with_doc

%if 0%{?with_python3}
BuildRequires:	python3-devel
BuildRequires:	python3-setuptools
BuildRequires:	python3-future >= 0.12.4
BuildRequires:	python3-numpy > 1.0.0
BuildRequires:	python3-mock
BuildRequires:	python3-scipy >= 0.9.0
BuildRequires:	python3-lxml
BuildRequires:	python3-matplotlib
BuildRequires:	python3-basemap
BuildRequires:	python3-sqlalchemy
BuildRequires:	python3-flake8 >= 2
BuildRequires:	python3-nose
%endif # with_python3

%if 0%{?el6}
Requires:	python-argparse
Requires:	python-importlib
%endif
Requires:	python2-future
Requires:	numpy
Requires:	scipy
Requires:	python-lxml
%if 0%{?fedora} <= 23
Requires:	python-matplotlib
%else
Requires:	python2-matplotlib
%endif
Requires:	python-basemap
Requires:	python-sqlalchemy
# These two are for matplotlib only
Requires:	python-mock

%if 0%{?with_python3}
%global __provides_exclude_from ^(%{python_sitearch}|%{python3_sitearch})/.*\\.so$
%else
%global __provides_exclude_from ^%{python_sitearch}/.*\\.so$
%endif


%description
ObsPy is an open-source project dedicated to provide a Python framework for
processing seismological data. It provides parsers for common file formats,
clients to access data centers and seismological signal processing routines
which allow the manipulation of seismological time series (see Beyreuther
et al. 2010, Megies et al. 2011).

The goal of the ObsPy project is to facilitate rapid application development
for seismology.


%if 0%{?with_python3}
%package -n python3-%{srcname}
Summary:	A Python Toolbox for seismology/seismological observatories
Group:		Development/Libraries

Requires:	python3-future
Requires:	python3-numpy
Requires:	python3-scipy
Requires:	python3-lxml
Requires:	python3-matplotlib
Requires:	python3-basemap
Requires:	python3-sqlalchemy
# These two are for matplotlib only
Requires:	python3-mock


%description -n python3-%{srcname}
ObsPy is an open-source project dedicated to provide a Python framework for
processing seismological data. It provides parsers for common file formats,
clients to access data centers and seismological signal processing routines
which allow the manipulation of seismological time series (see Beyreuther
et al. 2010, Megies et al. 2011).

The goal of the ObsPy project is to facilitate rapid application development
for seismology.
%endif # with_python3


%if 0%{?with_doc}
%package doc
Summary:	A Python Toolbox for seismology/seismological observatories
Group:		Documentation

%description doc
Documentation for ObsPy.
%endif # with_doc


%prep
%setup -q -n %{srcname}-%{commit}

%patch1 -p1

echo %{version} > obspy/RELEASE-VERSION

%if 0%{?with_python3}
rm -rf %{py3dir}
cp -a . %{py3dir}
find %{py3dir} -name '*.py' | xargs sed -i '1s|^#!python|#!%{__python3}|'
%endif # with_python3

find -name '*.py' | xargs sed -i '1s|^#!python|#!%{__python2}|'


%build
CFLAGS="%{optflags}" %{__python2} setup.py --with-system-libs build
%if 0%{?with_doc}
%{__python2} setup.py build_man
%endif # with_doc

%if 0%{?with_python3}
pushd %{py3dir}
CFLAGS="%{optflags}" %{__python3} setup.py --with-system-libs build
%if 0%{?with_doc}
%{__python3} setup.py build_man
%endif # with_doc
popd
%endif # with_python3


%install
# Must do the python2 install first because the scripts in /usr/bin are
# overwritten with every setup.py install (and we want the python3 version
# to be the default).
%{__python2} setup.py install --skip-build --root %{buildroot}

pushd %{buildroot}%{_bindir}
for prog in %{obspy_programs};
do
	mv obspy-${prog} obspy-${prog}-%{python2_version}
	ln -s obspy-${prog}-%{python2_version} obspy-${prog}-2
%if 0%{!?with_python3}
	ln -s obspy-${prog}-2 obspy-${prog}
%endif
done
popd

%if 0%{?with_doc}
%{__python2} setup.py install_man --skip-build --root %{buildroot}

pushd %{buildroot}%{_mandir}/man1
for prog in %{obspy_programs};
do
	mv obspy-${prog}.1 obspy-${prog}-%{python2_version}.1
	ln -s obspy-${prog}-%{python2_version}.1 obspy-${prog}-2.1
%if 0%{!?with_python3}
	ln -s obspy-${prog}-2.1 obspy-${prog}.1
%endif
done
popd

#%if 0%{!?with_python3}
pushd misc/docs
%if 0%{?fedora}
PYTHONPATH="%{buildroot}%{python2_sitearch}" make pep8 PYTHON="%{__python2}"
%endif
PYTHONPATH="%{buildroot}%{python2_sitearch}" make html PYTHON="%{__python2}"
rm build/html/.buildinfo
popd
%endif
#%endif # with_doc


%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py install --skip-build --root %{buildroot}
%if 0%{?with_doc}
%{__python3} setup.py install_man --skip-build --root %{buildroot}
%endif # with_doc
popd

pushd %{buildroot}%{_bindir}
for prog in %{obspy_programs};
do
	mv obspy-${prog} obspy-${prog}-%{python3_version}
	ln -s obspy-${prog}-%{python3_version} obspy-${prog}-3
	ln -s obspy-${prog}-3 obspy-${prog}
done
popd

%if 0%{?with_doc}
pushd %{buildroot}%{_mandir}/man1
for prog in %{obspy_programs};
do
	mv obspy-${prog}.1 obspy-${prog}-%{python3_version}.1
	ln -s obspy-${prog}-%{python3_version}.1 obspy-${prog}-3.1
	ln -s obspy-${prog}-3.1 obspy-${prog}.1
done
popd

#pushd misc/docs
#%if 0%{?fedora}
#PYTHONPATH="%{buildroot}%{python3_sitearch}" make pep8 PYTHON="%{__python3}"
#%endif
#PYTHONPATH="%{buildroot}%{python3_sitearch}" make html PYTHON="%{__python3}" SPHINXBUILD=sphinx-build-%{python3_version}
#rm build/html/.buildinfo
#popd
%endif # with_doc
%endif # with_python3

%check
%if 0%{?fedora}
PYTHONPATH="%{buildroot}%{python2_sitearch}" PATH="%{buildroot}%{_bindir}:$PATH" \
	obspy-runtests-2 -d
%else
PYTHONPATH="%{buildroot}%{python2_sitearch}" PATH="%{buildroot}%{_bindir}:$PATH" \
	OBSPY_NO_FLAKE8=yes obspy-runtests-2 -d
%endif

%if 0%{?with_python3}
pushd %{py3dir}
PYTHONPATH="%{buildroot}%{python3_sitearch}" PATH="%{buildroot}%{_bindir}:$PATH" \
	obspy-runtests-3 -d
popd
%endif # with_python3


%files
%if 0%{?el6}
%doc README.md CHANGELOG.txt CONTRIBUTING.md LICENSE.txt
%else
%doc README.md CHANGELOG.txt CONTRIBUTING.md
%license LICENSE.txt
%endif

%if 0%{!?with_python3}
%{_bindir}/%{srcname}-dataless2resp
%{_bindir}/%{srcname}-dataless2xseed
%{_bindir}/%{srcname}-flinn-engdahl
%{_bindir}/%{srcname}-indexer
%{_bindir}/%{srcname}-mopad
%{_bindir}/%{srcname}-mseed-recordanalyzer
%{_bindir}/%{srcname}-plot
%{_bindir}/%{srcname}-print
%{_bindir}/%{srcname}-reftek-rescue
%{_bindir}/%{srcname}-runtests
%{_bindir}/%{srcname}-scan
%{_bindir}/%{srcname}-xseed2dataless
%endif # !with_python3

%{_bindir}/%{srcname}-dataless2resp-2
%{_bindir}/%{srcname}-dataless2xseed-2
%{_bindir}/%{srcname}-flinn-engdahl-2
%{_bindir}/%{srcname}-indexer-2
%{_bindir}/%{srcname}-mopad-2
%{_bindir}/%{srcname}-mseed-recordanalyzer-2
%{_bindir}/%{srcname}-plot-2
%{_bindir}/%{srcname}-print-2
%{_bindir}/%{srcname}-reftek-rescue-2
%{_bindir}/%{srcname}-runtests-2
%{_bindir}/%{srcname}-scan-2
%{_bindir}/%{srcname}-xseed2dataless-2

%{_bindir}/%{srcname}-dataless2resp-%{python2_version}
%{_bindir}/%{srcname}-dataless2xseed-%{python2_version}
%{_bindir}/%{srcname}-flinn-engdahl-%{python2_version}
%{_bindir}/%{srcname}-indexer-%{python2_version}
%{_bindir}/%{srcname}-mopad-%{python2_version}
%{_bindir}/%{srcname}-mseed-recordanalyzer-%{python2_version}
%{_bindir}/%{srcname}-plot-%{python2_version}
%{_bindir}/%{srcname}-print-%{python2_version}
%{_bindir}/%{srcname}-reftek-rescue-%{python2_version}
%{_bindir}/%{srcname}-runtests-%{python2_version}
%{_bindir}/%{srcname}-scan-%{python2_version}
%{_bindir}/%{srcname}-xseed2dataless-%{python2_version}

%if 0%{?with_doc}
%if 0%{!?with_python3}
%{_mandir}/man1/%{srcname}-dataless2resp.1*
%{_mandir}/man1/%{srcname}-dataless2xseed.1*
%{_mandir}/man1/%{srcname}-flinn-engdahl.1*
%{_mandir}/man1/%{srcname}-indexer.1*
%{_mandir}/man1/%{srcname}-mopad.1*
%{_mandir}/man1/%{srcname}-mseed-recordanalyzer.1*
%{_mandir}/man1/%{srcname}-plot.1*
%{_mandir}/man1/%{srcname}-print.1*
%{_mandir}/man1/%{srcname}-reftek-rescue.1*
%{_mandir}/man1/%{srcname}-runtests.1*
%{_mandir}/man1/%{srcname}-scan.1*
%{_mandir}/man1/%{srcname}-xseed2dataless.1*
%endif # !with_python3

%{_mandir}/man1/%{srcname}-dataless2resp-2.1*
%{_mandir}/man1/%{srcname}-dataless2xseed-2.1*
%{_mandir}/man1/%{srcname}-flinn-engdahl-2.1*
%{_mandir}/man1/%{srcname}-indexer-2.1*
%{_mandir}/man1/%{srcname}-mopad-2.1*
%{_mandir}/man1/%{srcname}-mseed-recordanalyzer-2.1*
%{_mandir}/man1/%{srcname}-plot-2.1*
%{_mandir}/man1/%{srcname}-print-2.1*
%{_mandir}/man1/%{srcname}-reftek-rescue-2.1*
%{_mandir}/man1/%{srcname}-runtests-2.1*
%{_mandir}/man1/%{srcname}-scan-2.1*
%{_mandir}/man1/%{srcname}-xseed2dataless-2.1*

%{_mandir}/man1/%{srcname}-dataless2resp-%{python2_version}.1*
%{_mandir}/man1/%{srcname}-dataless2xseed-%{python2_version}.1*
%{_mandir}/man1/%{srcname}-flinn-engdahl-%{python2_version}.1*
%{_mandir}/man1/%{srcname}-indexer-%{python2_version}.1*
%{_mandir}/man1/%{srcname}-mopad-%{python2_version}.1*
%{_mandir}/man1/%{srcname}-mseed-recordanalyzer-%{python2_version}.1*
%{_mandir}/man1/%{srcname}-plot-%{python2_version}.1*
%{_mandir}/man1/%{srcname}-print-%{python2_version}.1*
%{_mandir}/man1/%{srcname}-reftek-rescue-%{python2_version}.1*
%{_mandir}/man1/%{srcname}-runtests-%{python2_version}.1*
%{_mandir}/man1/%{srcname}-scan-%{python2_version}.1*
%{_mandir}/man1/%{srcname}-xseed2dataless-%{python2_version}.1*
%endif # with_doc

%{python2_sitearch}/%{srcname}*


%if 0%{?with_doc}
%files doc
%doc misc/docs/build/html
%endif # with_doc


%if 0%{?with_python3}
%files -n python3-%{srcname}
%doc README.md CHANGELOG.txt CONTRIBUTING.md
%license LICENSE.txt

%{_bindir}/%{srcname}-dataless2resp
%{_bindir}/%{srcname}-dataless2xseed
%{_bindir}/%{srcname}-flinn-engdahl
%{_bindir}/%{srcname}-indexer
%{_bindir}/%{srcname}-mopad
%{_bindir}/%{srcname}-mseed-recordanalyzer
%{_bindir}/%{srcname}-plot
%{_bindir}/%{srcname}-print
%{_bindir}/%{srcname}-reftek-rescue
%{_bindir}/%{srcname}-runtests
%{_bindir}/%{srcname}-scan
%{_bindir}/%{srcname}-xseed2dataless

%{_bindir}/%{srcname}-dataless2resp-3
%{_bindir}/%{srcname}-dataless2xseed-3
%{_bindir}/%{srcname}-flinn-engdahl-3
%{_bindir}/%{srcname}-indexer-3
%{_bindir}/%{srcname}-mopad-3
%{_bindir}/%{srcname}-mseed-recordanalyzer-3
%{_bindir}/%{srcname}-plot-3
%{_bindir}/%{srcname}-print-3
%{_bindir}/%{srcname}-reftek-rescue-3
%{_bindir}/%{srcname}-runtests-3
%{_bindir}/%{srcname}-scan-3
%{_bindir}/%{srcname}-xseed2dataless-3

%{_bindir}/%{srcname}-dataless2resp-%{python3_version}
%{_bindir}/%{srcname}-dataless2xseed-%{python3_version}
%{_bindir}/%{srcname}-flinn-engdahl-%{python3_version}
%{_bindir}/%{srcname}-indexer-%{python3_version}
%{_bindir}/%{srcname}-mopad-%{python3_version}
%{_bindir}/%{srcname}-mseed-recordanalyzer-%{python3_version}
%{_bindir}/%{srcname}-plot-%{python3_version}
%{_bindir}/%{srcname}-print-%{python3_version}
%{_bindir}/%{srcname}-reftek-rescue-%{python3_version}
%{_bindir}/%{srcname}-runtests-%{python3_version}
%{_bindir}/%{srcname}-scan-%{python3_version}
%{_bindir}/%{srcname}-xseed2dataless-%{python3_version}

%if 0%{?with_doc}
%{_mandir}/man1/%{srcname}-dataless2resp.1*
%{_mandir}/man1/%{srcname}-dataless2xseed.1*
%{_mandir}/man1/%{srcname}-flinn-engdahl.1*
%{_mandir}/man1/%{srcname}-indexer.1*
%{_mandir}/man1/%{srcname}-mopad.1*
%{_mandir}/man1/%{srcname}-mseed-recordanalyzer.1*
%{_mandir}/man1/%{srcname}-plot.1*
%{_mandir}/man1/%{srcname}-print.1*
%{_mandir}/man1/%{srcname}-reftek-rescue.1*
%{_mandir}/man1/%{srcname}-runtests.1*
%{_mandir}/man1/%{srcname}-scan.1*
%{_mandir}/man1/%{srcname}-xseed2dataless.1*

%{_mandir}/man1/%{srcname}-dataless2resp-3.1*
%{_mandir}/man1/%{srcname}-dataless2xseed-3.1*
%{_mandir}/man1/%{srcname}-flinn-engdahl-3.1*
%{_mandir}/man1/%{srcname}-indexer-3.1*
%{_mandir}/man1/%{srcname}-mopad-3.1*
%{_mandir}/man1/%{srcname}-mseed-recordanalyzer-3.1*
%{_mandir}/man1/%{srcname}-plot-3.1*
%{_mandir}/man1/%{srcname}-print-3.1*
%{_mandir}/man1/%{srcname}-reftek-rescue-3.1*
%{_mandir}/man1/%{srcname}-runtests-3.1*
%{_mandir}/man1/%{srcname}-scan-3.1*
%{_mandir}/man1/%{srcname}-xseed2dataless-3.1*

%{_mandir}/man1/%{srcname}-dataless2resp-%{python3_version}.1*
%{_mandir}/man1/%{srcname}-dataless2xseed-%{python3_version}.1*
%{_mandir}/man1/%{srcname}-flinn-engdahl-%{python3_version}.1*
%{_mandir}/man1/%{srcname}-indexer-%{python3_version}.1*
%{_mandir}/man1/%{srcname}-mopad-%{python3_version}.1*
%{_mandir}/man1/%{srcname}-mseed-recordanalyzer-%{python3_version}.1*
%{_mandir}/man1/%{srcname}-plot-%{python3_version}.1*
%{_mandir}/man1/%{srcname}-print-%{python3_version}.1*
%{_mandir}/man1/%{srcname}-reftek-rescue-%{python3_version}.1*
%{_mandir}/man1/%{srcname}-runtests-%{python3_version}.1*
%{_mandir}/man1/%{srcname}-scan-%{python3_version}.1*
%{_mandir}/man1/%{srcname}-xseed2dataless-%{python3_version}.1*
%endif # with_doc

%{python3_sitearch}/%{srcname}*
%endif # with_python3


%changelog
* Sat Apr 16 2016 Elliott Sales de Andrade <quantum.analyst@gmail.com> 0.10.3-1
- New upstream release
- Bump for EPEL 6
- Update future dependency to match official Fedora/EPEL naming
- Add python-mock to requirements since matplotlib falsely needs it
- Stop building documentation against mlpy

* Sat May 16 2015 Elliott Sales de Andrade <quantum.analyst@gmail.com> 0.10.2-2
- Add BR on python-pybtex
- Patch to build with NumPy 1.4

* Fri May 15 2015 Elliott Sales de Andrade <quantum.analyst@gmail.com> 0.10.2-1
- New upstream release

* Fri Mar 20 2015 Elliott Sales de Andrade <quantum.analyst@gmail.com> 0.10.1-1
- New upstream release

* Thu Mar 19 2015 Elliott Sales de Andrade <quantum.analyst@gmail.com> 0.10.0-2
- Fix error in stored version

* Thu Mar 19 2015 Elliott Sales de Andrade <quantum.analyst@gmail.com> 0.10.0-1
- Initial RPM release
